<script setup>
// imports
import { ref, computed, inject } from "vue";
import IconArrow from "@/components/icons/IconArrow.vue";
import DotsLoadingIcon from "@/components/icons/DotsLoadingIcon.vue";
import { api, error_handler } from "@/services/api.service";
import { useBaseStore } from "@/stores/base";
import { push } from "notivue";
import router from "@/router";

// store
const baseStore = useBaseStore();
// cookie
const $cookies = inject("$cookies");
// data
const phoneNumber = ref("");
const password = ref("");
const fieldFilled = ref(false);
const loading = ref(false);
// methods
const loginFormSubmitHandler = (e) => {
  if (!fieldFilled.value) {
    e.preventDefault();
  } else {
    loading.value = true;
    const loginForm = new FormData();
    console.log(typeof baseStore.csrf_token);
    loginForm.append("form_name", "login_form3");
    loginForm.append("csrf_token", baseStore.csrf_token + "");
    loginForm.append("customer_number", phoneNumber.value + "");
    loginForm.append("password", password.value + "");
    api
      .post("https://www.ayandehexchange.com/API/auth", loginForm, {
        headers: {
          "Content-Type": "multipart/form-data",
        },
      })
      .then((res) => {
        $cookies.set("jwt", res.data.data.jwt, 60 * 60 * 4320);
        push.success("You have successfully logged in");
        baseStore.getUserData(res.data.data.jwt);
        router.push("/");
      })
      .catch((err) => error_handler(err))
      .finally(() => (loading.value = false));
  }
};
const validateFormInputs = () => {
  fieldFilled.value = !!phoneNumber.value && !!password.value;
};

const getInitialToken = () => {
  const csrfFormData = new FormData();
  csrfFormData.append("form_name", "login_form3");

  api
    .post("https://www.ayandehexchange.com/API/get_csrf_token", csrfFormData, {
      headers: {
        "Content-Type": "multipart/form-data",
      },
    })
    .then((res) => {
      const baseStore = useBaseStore();
      baseStore.csrf_token = res.data.data.csrf_token;
    })
    .catch(() => {
      error_handler()
    });
};
getInitialToken()
</script>
<template>
  <div
    class="max-w-[468px] w-full p-8 mx-auto bg-bg-primary h-full overflow-y-auto relative"
  >
    <router-link to="/" class="flex items-center gap-2 mb-5">
      <IconArrow class="w-[22px]" />
      <div class="text-txt-primary text-[22px] font-bold">Login</div>
    </router-link>
    <form @submit.stop.prevent="loginFormSubmitHandler">
      <input
        @input="validateFormInputs"
        v-model="phoneNumber"
        class="w-full bg-white p-3 rounded-lg outline-none text-txt-primary border border-neutral-200"
        type="text"
        placeholder="Enter your customer number"
      />
      <input
        @input="validateFormInputs"
        v-model="password"
        class="w-full bg-white p-3 rounded-lg outline-none text-txt-primary border border-neutral-200 mt-3"
        type="password"
        placeholder="Enter your password"
      />
      <button
        type="submit"
        :class="{ 'pointer-events-none opacity-60': loading || !fieldFilled }"
        class="bg-black text-white max-h-[48px] flex items-center justify-center p-3 w-full rounded-lg mt-3"
      >
        <DotsLoadingIcon v-if="loading" class="text-white" />
        <span v-else>Login</span>
      </button>
    </form>
  </div>
</template>
